part of tecfy_core_client_package;

class NotificationApp extends BaseModel {
  String id;
  int type;
  bool showNowOnly;
  String titleAr;
  String titleEn;
  String get title => LocalConfigService.isArabic ? titleAr : titleEn;
  String messageAr;
  String messageEn;
  String get message => LocalConfigService.isArabic ? messageAr : messageEn;
  bool seen;
  String ownerUserId;
  String payload;
  DateTime time;

  NotificationApp({
    this.id,
    this.type,
    this.showNowOnly,
    this.titleAr,
    this.titleEn,
    this.messageAr,
    this.messageEn,
    this.seen,
    this.ownerUserId,
    this.time,
    this.payload,
  });
  String get timeString => time == null
      ? ''
      : intl.DateFormat("MMM-dd hh:mm a")
          .format(time); //. time?.toString() ?? '-';

  NotificationApp.fromMap(Map row) {
    id = row['id'];
    type = row['type'];
    showNowOnly = row['showNowOnly'] ?? false;
    titleAr = row['titleAr'] ?? '';
    titleEn = row['titleEn'] ?? '';
    messageAr = row['messageAr'] ?? '';
    messageEn = row['messageEn'] ?? '';
    seen = row['seen'] == 1 || row['seen'] == true;
    ownerUserId = row['ownerUserId'] ?? '';
    payload = row['payload'] ?? '';
    if(row['createdTime'] != null){
      time = intl.DateFormat("yyyy-MM-ddTHH:mm:ss").parseUtc(row['createdTime']);
      //DateTime.tryParse(row['createdTime'],  );
    }else{
      time = DateTime.fromMillisecondsSinceEpoch(row['time'] ?? 0, isUtc: true);
    }
  }

  toMapDb() {
    return {
      'id': id,
      'type': type,
      //'showNowOnly': showNowOnly,
      'titleAr': titleAr,
      'titleEn': titleEn,
      'messageAr': messageAr,
      'messageEn': messageEn,
      'seen': seen ? 1 : 0,
      //'ownerUserId': ownerUserId,
      'time': time.millisecondsSinceEpoch,
      'payload': payload,
    };
  }

  @override
  String get displayName => null;

  @override
  String get idValue => null;
}
