part of tecfy_core_client_package;

class DateProperty extends StatefulWidget {
  final String label;
  final dynamic initalValue;
  final void Function(DateTime) onChanged;
  DateProperty({this.label, this.initalValue, this.onChanged});
  @override
  _DatePropertyState createState() => _DatePropertyState();
}

class _DatePropertyState extends State<DateProperty> {
  DateTime selectedValue;

  @override
  void initState() {
    print('initalValue : ${widget.initalValue}');
    if(widget.initalValue is String)
    {
      if(widget.initalValue != null){
        print('trying to parse');
        selectedValue = DateTime.tryParse(widget.initalValue);
      }
    }else{
      selectedValue = widget.initalValue;
    }
    super.initState();
  }

  void onPressed()async{
    var value = await showDatePicker(context: context,firstDate: DateTime(1900),initialDate: selectedValue ?? DateTime.now().toUtc(),lastDate: DateTime(2500));    
    setState(() {
      selectedValue = value;
    });
    if(widget.onChanged!= null)
      widget.onChanged(selectedValue);
  }

  onPrint(){

    if(selectedValue == null && widget.initalValue != null){
      selectedValue = widget.initalValue;
    }

  }

  @override
  Widget build(BuildContext context) {
    onPrint();
    return MaterialButton(
      padding: EdgeInsets.all(0),
      onPressed: onPressed,
        child: Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: <Widget>[
        SizedBox(height: 10),
        Text(
          widget.label ?? '',
          style: ThemeService.labelStyle,
        ),
        Text( selectedValue != null ? intl.DateFormat("dd/MM/yyyy").format(selectedValue) : '[Click To Select]'),
        SizedBox(height: 10),
        Container(height: 1, color: ThemeService.textSubColor)
      ],
    ));
  }
}
