// import 'package:flutter/material.dart';
// import 'package:tecfy_core_package/services/app_localizations.dart';
// import 'package:tecfy_core_package/services/entity.service.dart';
part of tecfy_core_client_package;

class DropdownEntity extends StatefulWidget {
  final Entity entity;
  final String label;
  final String initalValue;
  final String filterField;
  final String filterValue;
  final bool isFilter;
  final void Function(String) onChanged;  
  DropdownEntity({this.label,this.entity,this.initalValue,this.onChanged,this.isFilter,this.filterField,this.filterValue});
  @override
  _DropdownEntityState createState() => _DropdownEntityState();
}

class _DropdownEntityState extends State<DropdownEntity> {

  List<dynamic> data;
  String _value;
  @override
  void initState() {
    _value = widget.initalValue;
    EntityService().getData(widget.entity).then((result){
      if(result.success){
        data = result.data;
        if(data.length == 1) {
          _value = data[0]['id'];
          widget.onChanged(_value);
        }
        setState(() {});
      }else result.showMessage(context);
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return data == null ? Text('${AppLocale.translate(context,'Loading')}..') : DropdownButtonFormField(
      decoration: InputDecoration(labelText: widget.label),
      value: data.any((d)=> (!widget.isFilter || widget.filterValue == d[widget.filterField]) && d['id'] == _value ) ? _value : null,
      onChanged: (v){
        _value = v;
        if(widget.onChanged != null)widget.onChanged(v);
        setState((){});
      },
      items: data
        .where((d)=> !widget.isFilter || widget.filterValue == d[widget.filterField])
        .map<DropdownMenuItem>((item)=>DropdownMenuItem(
        child: Text(item['display'] ?? item['name'] ?? item['nameAr'] ?? item['nameEn'] ?? 'N/A'),
        value: item['id'],
      )).toList()..add(
        _value == null ? DropdownMenuItem(child: Container(),) : DropdownMenuItem(
          child: Text('غير محدد',style:TextStyle(color:Colors.red)),
          value: null,
        )
      ),
    );
  }
}