part of tecfy_core_client_package;

class ReportListPage extends StatefulWidget {
  @override
  _ReportListPageState createState() => _ReportListPageState();
}

class _ReportListPageState extends State<ReportListPage> {

  List<dynamic> reports;

  @override
  void initState() {
    getData();
    super.initState();
  }

  getData()async{
    var result = await ApiService.httpGetDynamic('Report/GetList');
    print(result.data);
    if(result.success){
      setState(() {
       reports = result.data; 
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(context, 'Reports',
      child: reports == null ? Center(child: CircularProgressIndicator(valueColor:AlwaysStoppedAnimation<Color>(ThemeService.mainColor))) : ListView(
        children: reports.map<Widget>((report)=>FlatButton(child: Text( report['name${LocalConfigService.languagePrefex}'] ?? 'N/A'),
              onPressed: ()async{                  
                  // AppNavigator.navigateTo(context, ()=>ReportFilterPage(report));
                  var result = await AppNavigator.navigateTo(context, ()=>EntityFilterPage(report['name${LocalConfigService.languagePrefex}'],report['filters'].map<Property>((r)=>Property.getProperty(r)).toList()),animationType: AnimationTypes.slideLeft) ;
                  bool canceled =false;
                  if(result == null) canceled =true;
                  var filter = (result as List<EntityFilter>).where((f)=>f.value != null && f.property != null && f.operatorId != null).toList();

                  if(!canceled){
                    AppNavigator.navigateTo(context, ()=>ReportDetailPage(report,filter));
                  }else{
                    Navigator.pop(context);
                  }

              },)).toList(),
      ),
    );
  }
}